%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  fact(N, F) es cierto si el factorial de F es N.

%  Este predicado sirve para calcular el factorial de N.
%  Es preciso que el parámetro N esté instanciado.  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fact(0, 1).

fact(N, F) :- N1 is N - 1, fact(N1, F1), F is N * F1.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  nat(N) es cierto si N es un número natural.

%  Este predicado sirve para generar números naturales
%  de menor a mayor. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nat(0).

nat(N) :- nat(N1), N is N1 + 1. 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  mcm(X,Y,M) es cierto si M es el mínimo común múltiplo de X e Y

%  Este predicado sirve para calcular el mcm de X e Y. 
%  Los parámetros X e Y deben estar instanciados, el
%  predicado instancia MULT en el mcm de X e Y. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mcm(X, Y, MULT) :- nat(N), N > 0, MULT is X * N, 0 is MULT mod Y.  